/**
 * Autogenerated by Thrift Compiler (0.10.0)
 *
 * DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
 *  @generated
 */
#include "Service_types.h"

#include <algorithm>
#include <ostream>

#include <thrift/TToString.h>

namespace chatgen {


ConnectionError::~ConnectionError() throw() {
}


void ConnectionError::__set_errorMessage(const std::string& val) {
  this->errorMessage = val;
}

uint32_t ConnectionError::read(::apache::thrift::protocol::TProtocol* iprot) {

  apache::thrift::protocol::TInputRecursionTracker tracker(*iprot);
  uint32_t xfer = 0;
  std::string fname;
  ::apache::thrift::protocol::TType ftype;
  int16_t fid;

  xfer += iprot->readStructBegin(fname);

  using ::apache::thrift::protocol::TProtocolException;


  while (true)
  {
    xfer += iprot->readFieldBegin(fname, ftype, fid);
    if (ftype == ::apache::thrift::protocol::T_STOP) {
      break;
    }
    switch (fid)
    {
      case 1:
        if (ftype == ::apache::thrift::protocol::T_STRING) {
          xfer += iprot->readString(this->errorMessage);
          this->__isset.errorMessage = true;
        } else {
          xfer += iprot->skip(ftype);
        }
        break;
      default:
        xfer += iprot->skip(ftype);
        break;
    }
    xfer += iprot->readFieldEnd();
  }

  xfer += iprot->readStructEnd();

  return xfer;
}

uint32_t ConnectionError::write(::apache::thrift::protocol::TProtocol* oprot) const {
  uint32_t xfer = 0;
  apache::thrift::protocol::TOutputRecursionTracker tracker(*oprot);
  xfer += oprot->writeStructBegin("ConnectionError");

  xfer += oprot->writeFieldBegin("errorMessage", ::apache::thrift::protocol::T_STRING, 1);
  xfer += oprot->writeString(this->errorMessage);
  xfer += oprot->writeFieldEnd();

  xfer += oprot->writeFieldStop();
  xfer += oprot->writeStructEnd();
  return xfer;
}

void swap(ConnectionError &a, ConnectionError &b) {
  using ::std::swap;
  swap(a.errorMessage, b.errorMessage);
  swap(a.__isset, b.__isset);
}

ConnectionError::ConnectionError(const ConnectionError& other0) : TException() {
  errorMessage = other0.errorMessage;
  __isset = other0.__isset;
}
ConnectionError& ConnectionError::operator=(const ConnectionError& other1) {
  errorMessage = other1.errorMessage;
  __isset = other1.__isset;
  return *this;
}
void ConnectionError::printTo(std::ostream& out) const {
  using ::apache::thrift::to_string;
  out << "ConnectionError(";
  out << "errorMessage=" << to_string(errorMessage);
  out << ")";
}

const char* ConnectionError::what() const throw() {
  try {
    std::stringstream ss;
    ss << "TException - service has thrown: " << *this;
    this->thriftTExceptionMessageHolder_ = ss.str();
    return this->thriftTExceptionMessageHolder_.c_str();
  } catch (const std::exception&) {
    return "TException - service has thrown: ConnectionError";
  }
}


InternalError::~InternalError() throw() {
}


void InternalError::__set_errorMessage(const std::string& val) {
  this->errorMessage = val;
}

uint32_t InternalError::read(::apache::thrift::protocol::TProtocol* iprot) {

  apache::thrift::protocol::TInputRecursionTracker tracker(*iprot);
  uint32_t xfer = 0;
  std::string fname;
  ::apache::thrift::protocol::TType ftype;
  int16_t fid;

  xfer += iprot->readStructBegin(fname);

  using ::apache::thrift::protocol::TProtocolException;


  while (true)
  {
    xfer += iprot->readFieldBegin(fname, ftype, fid);
    if (ftype == ::apache::thrift::protocol::T_STOP) {
      break;
    }
    switch (fid)
    {
      case 1:
        if (ftype == ::apache::thrift::protocol::T_STRING) {
          xfer += iprot->readString(this->errorMessage);
          this->__isset.errorMessage = true;
        } else {
          xfer += iprot->skip(ftype);
        }
        break;
      default:
        xfer += iprot->skip(ftype);
        break;
    }
    xfer += iprot->readFieldEnd();
  }

  xfer += iprot->readStructEnd();

  return xfer;
}

uint32_t InternalError::write(::apache::thrift::protocol::TProtocol* oprot) const {
  uint32_t xfer = 0;
  apache::thrift::protocol::TOutputRecursionTracker tracker(*oprot);
  xfer += oprot->writeStructBegin("InternalError");

  xfer += oprot->writeFieldBegin("errorMessage", ::apache::thrift::protocol::T_STRING, 1);
  xfer += oprot->writeString(this->errorMessage);
  xfer += oprot->writeFieldEnd();

  xfer += oprot->writeFieldStop();
  xfer += oprot->writeStructEnd();
  return xfer;
}

void swap(InternalError &a, InternalError &b) {
  using ::std::swap;
  swap(a.errorMessage, b.errorMessage);
  swap(a.__isset, b.__isset);
}

InternalError::InternalError(const InternalError& other2) : TException() {
  errorMessage = other2.errorMessage;
  __isset = other2.__isset;
}
InternalError& InternalError::operator=(const InternalError& other3) {
  errorMessage = other3.errorMessage;
  __isset = other3.__isset;
  return *this;
}
void InternalError::printTo(std::ostream& out) const {
  using ::apache::thrift::to_string;
  out << "InternalError(";
  out << "errorMessage=" << to_string(errorMessage);
  out << ")";
}

const char* InternalError::what() const throw() {
  try {
    std::stringstream ss;
    ss << "TException - service has thrown: " << *this;
    this->thriftTExceptionMessageHolder_ = ss.str();
    return this->thriftTExceptionMessageHolder_.c_str();
  } catch (const std::exception&) {
    return "TException - service has thrown: InternalError";
  }
}

} // namespace
